unit BGRAspeed1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
	 BGRAGraphicControl, BGRAbitmap, BGRABitmapTypes;

type

	 { TForm1 }

   TForm1 = class(TForm)
			BGRAgc: TBGRAGraphicControl;
			Button1: TButton;
			procedure BGRAgcPaint(Sender: TObject);
   procedure Button1Click(Sender: TObject);
			procedure FormCreate(Sender: TObject);
   private
   col : TBGRAPixel;
   go : boolean;
   startTime: QWord;
   frameCount: Integer;
   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);

begin
go := not go;
frameCount := 0;
startTime := GetTickCount64;
while go do
  begin
  BGRAgc.Invalidate;
  Application.ProcessMessages;
	end;

end;

procedure TForm1.BGRAgcPaint(Sender: TObject);
var fps : single;
    s: string;

begin
BGRAgc.Bitmap.Fill(BGRA (random(256),random(256),random(256)));
inc (frameCount);
fps := frameCount /(GetTickCount64 - startTime)* 1000;
s := IntToStr(round(fps));
BGRAgc.Bitmap.textout (0,0,s+' frames per sec',CSSBlack);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   go := false;
end;

end.

